<template>
  <view-list
    v-on:model-reload="loadList"
    v-on:export-csv="downloadCsv"
    v-on:model-search="search($event.query, $event.field)"
    :status="status"
    title="Osoby"
    :button="true"
    button_link="/osoby/nowa"
    button_title="Dodaj nową osobę"
    :length="filteredData.length"
  >
    <RecycleScroller v-if="renderHack" :items="filteredData" :item-size="106">
      <template v-slot="{ item }">
        <user-list-item v-bind="item" />
      </template>
    </RecycleScroller>
  </view-list>
</template>

<script lang="ts">
import { Options } from "vue-class-component";

import ViewList from "@/views/list-views/ViewList.vue";
import UserListItem from "@/components/list/custom/UserListItem.vue";

import { UserData, LoadingState, CsvDownload } from "@/interfaces";
import RecordList from "@/views/list-views/RecordList";
import { NApi } from "@/interfaces/connector";
import Fuse from "fuse.js";
import FuseResult = Fuse.FuseResult;

@Options({
  components: {
    ViewList,
    UserListItem,
  },
})
export default class Users extends RecordList<UserData> {
  public API_CALL = NApi.getUsers;

  async downloadCsv() {
    await new CsvDownload(" ; ").download(this.filteredData);
  }

  async onLoaded(data: UserData[]) {
    const options = {
      includeScore: false,
      keys: ["name", "surname", "email"],
    };

    this.rawData = data;
    this.fuseData = Object.freeze(new Fuse(data, options));
    this.filter();
  }
}
</script>
